$vCommanderServer = 'your.vcommander.address'
$CredFile = 'C:\script\creds\superuser_cred.xml' #Encrypted Credential file to connect to vcommander
$desiredFormat = "THIN"
#$desiredFormat = "THICK_LAZY"
#$desiredFormat = "THICK_EAGER" 

$moduleName = "VCommanderRestClient"
If (-not (Get-Module -name $moduleName)) {
                Import-Module -Name $moduleName
} else {
                Remove-Module $moduleName
                Import-Module -Name $moduleName
}
$moduleName = "VCommander"
If (-not (Get-Module -name $moduleName)) {
                Import-Module -Name $moduleName
} else {
                Remove-Module $moduleName
                Import-Module -Name $moduleName
}

#Connecting to vCommander
$Global:SERVICE_HOST = $vCommanderServer
$Global:REQUEST_HEADERS =@{}
$Global:BASE_SERVICE_URI = $Global:BASE_SERVICE_URI_PATTERN.Replace("{service_host}",$Global:SERVICE_HOST)  
$cred = (New-DecryptCredential -keyFilePath $CredFile)       
$Global:CREDENTIAL = $cred
VCommander\Set-IgnoreSslErrors
Set-BaseServiceURI "https://$vCommanderServer/webservices/services/rest/v2"
Connect-Client | Out-Null

echo "Now connected to vCommander"

$offset = 0
$orgRefs = Get-OrganizationReferences -max 20 -offset $offset 
while($orgRefs.ManagedObjectReferenceCollection.ManagedObjectReferences.Count -gt 0) {
    foreach($orgRef in $orgRefs.ManagedObjectReferenceCollection.ManagedObjectReferences) {
        Start-Sleep 2 # 2 second sleep so we don't cause performance issues

        $destinations = Get-DeploymentDestinationsByOrg -orgid $orgRef.id
        foreach($destination in $destinations.DeploymentDestinationCollection.DeploymentDestinations) {
            if($destination.diskFormat -ne $desiredFormat) {
                $oldFormat = $destination.diskFormat
                $destination.diskFormat = $desiredFormat

                # Create a new object to update the destination
                $newDestination = New-Object PSObject
                Add-Member -InputObject $newDestination -MemberType NoteProperty -Name "VMWareDeploymentDestination" -Value $destination -Force
                try {
                    $updatedDD = Update-DeploymentDestination -id $newDestination.VMWareDeploymentDestination.id -updatedDeploymentDestination $newDestination
                    Write-Host "$($orgRef.displayName) - destination '$($destination.name)' was converted from $($oldFormat) to $($desiredFormat)"
                } catch {
                    $Exception = $_
                    Write-Host "$($orgRef.displayName) - error converting destination '$($destination.name)' from $($oldFormat) to $($desiredFormat) - $($Exception.ErrorDetails)"
                }
            } else {
                Write-Host "$($orgRef.displayName) - destination '$($destination.name)' was already set to $($desiredFormat)"
            }
        }
    }

    $offset = $offset + 20
    $orgRefs = Get-OrganizationReferences -max 20 -offset $offset 
}